::=========================================::
:: Script by Luffaren (STEAM_1:1:22521282) ::
::=========================================::
::  This .bat file uses "bspzip.exe" by Valve
::  It simply packs everything within the 'csgo' folder next to the .bsp that you drag+drop
::  Usage: drag+drop the .bsp into this .bat file
::  The .bsp is then packed
::  (note that this is meant for a specific project/folder structure)
::  (to learn more, drag+drop a .bsp that has no 'csgo' folder next to it)
::-------------------------------------------------------------------------------------------------------
::		[FOLDER PATHS]
@echo off
SET bspzip_path=C:\Program Files (x86)\Steam\steamapps\common\Counter-Strike Global Offensive\bin\bspzip.exe
SET gameinfo_folder=C:\Program Files (x86)\Steam\steamapps\common\Counter-Strike Global Offensive\csgo
::-------------------------------------------------------------------------------------------------------
echo ----------------------------------------------------------------------------------------------------
echo [Luffaren STEAM_1:1:22521282]
echo -----------------------------
IF exist "%~dp0PACKBSP_templist" del "%~dp0PACKBSP_templist"
IF "%~1" == "" GOTO:error_no_file
IF NOT "%~x1" == ".bsp" GOTO:error_invalid_file
IF NOT exist "%bspzip_path%" GOTO:error_invalid_bspzip_path
IF NOT exist "%gameinfo_folder%" GOTO:error_invalid_gameinfo_folder_path
IF NOT exist "%~d1%~p1csgo" GOTO:error_invalid_project_csgo_path
echo [INFO]           Packing everything within:  "%~d1%~p1csgo\"
echo [INFO]           Into this .bsp file:        "%~1"
echo:
echo Close this window to cancel . . .
pause
setlocal enableDelayedExpansion
for /f %%i in ('dir %~d1%~p1csgo\* /s /b /a-d 2^> nul ^| find "" /v /c') do set filecount_max=%%i
For /R "csgo\" %%G IN (*) do (
	SET _test=%%G
	SET _result=!_test:%~d1%~p1csgo\=!
	ECHO !_result!
	echo !_result!>> "%~dp0PACKBSP_templist"
	echo %%G>> "%~dp0PACKBSP_templist"
)
"%bspzip_path%" -addlist "%~1" "%~dp0PACKBSP_templist" "%~1" -game "%gameinfo_folder%" >NUL

echo:
echo [INFO]           Packed %filecount_max% files
GOTO:endcode

:error_no_file
echo [ERROR]          No file was added, you must drag+drop a .bsp file into this .bat file!
GOTO:endcode

:error_invalid_file
echo [ERROR]          The added file was not a .bsp file, you must drag+drop a .bsp file into this .bat file!
GOTO:endcode

:error_invalid_bspzip_path
echo [ERROR]          The 'bspzip_path' is invalid, edit the variable/path at the top of this .bat file! ([FOLDER PATHS])
echo                  It should usually be this:
echo                     C:\Program Files (x86)\Steam\steamapps\common\Counter-Strike Global Offensive\bin\bspzip.exe
GOTO:endcode

:error_invalid_gameinfo_folder_path
echo [ERROR]          The 'gameinfo_folder' is invalid, edit the variable/path at the top of this .bat file! ([FOLDER PATHS])
echo                  It should usually be this (the folder where gameinfo.txt lies):
echo                     C:\Program Files (x86)\Steam\steamapps\common\Counter-Strike Global Offensive\csgo
GOTO:endcode

:error_invalid_project_csgo_path
echo [ERROR]     ^|   No 'csgo' folder was found next to the .bsp file, this app won't know what to pack!
echo             ^|   This app is very simple, it packs *EVERYTHING* from the 'csgo' folder into the .bsp.
echo             ^|   The 'csgo' folder should be separate, only containing custom assets used by the map.
echo             ^|   The *real* 'csgo' folder in your steam dir shouldn't be used for this, it'd pack too much.
echo             ^|   And you should edit 'csgo/gameinfo.txt' in your real 'csgo' folder to point assets here^:
echo             ^|          for example:          Game      "C:\absolutepath...\ze_myproject\csgo"
echo             ^|   A decent custom project folder setup should be something along the lines of this:
echo             ^|   
echo             ^|-------[ze_myproject]
echo                     ^|
echo                     ^|---- ze_myproject.vmf
echo                     ^|---- ze_myproject.bsp      (the .bsp file you should drag+drop)
echo                     ^|---- PACKBSP.bat           (this .bat file)
echo                     ^|
echo                     ^|-----[csgo]                 (everything under here will be packed into the .bsp)
echo                           ^|
echo                           ^|-----[materials]
echo                           ^|     ^|...
echo                           ^|
echo                           ^|-----[models]
echo                           ^|     ^|...
echo                           ^|
echo                           ^|-----[scripts]
echo                           ^|     ^|...
echo                           ^|...
GOTO:endcode

:endcode
echo [INFO]           Finished
IF exist "%~dp0PACKBSP_templist" del "%~dp0PACKBSP_templist"
echo ----------------------------------------------------------------------------------------------------
pause
